﻿Type=Class
Version=2.02
@EndOfDesignText@
'version: 1.10
Sub Class_Globals
	Private ges As Gestures
	Private width, height As Int
	Private pnlRect As Rect
	Public NONE, LEFT, RIGHT, UP, DOWN
	NONE = 0
	LEFT = 1
	RIGHT = 2
	UP = 3
	DOWN = 4
	Type joystick(x As Float, y As Float, zeroX As Float, zeroY As Float, color As Int, bd As BitmapData)
	Dim jleft, jright As joystick
	Private radius As Int
	Private TouchMap As Map
End Sub

Public Sub Initialize (parent As View)
	ges.SetOnTouchListener(parent, "pnl_multitouch")
	jleft.Initialize
	jleft.color = Colors.Red
	jright.Initialize
	jright.color = Colors.Blue
	TouchMap.Initialize
End Sub

Public Sub AddToGameView(gv As GameView, vLeft As Int, vTop As Int, vWidth As Int, vHeight As Int)
	width = vWidth
	height = vHeight
	pnlRect.Initialize(vLeft, vTop, vWidth, vHeight)

	'add the two arrows
	Dim arrows As Bitmap
	arrows = LoadBitmap(File.DirAssets, "arrows.png")
	Dim bd1, bd2 As BitmapData
	bd1.Bitmap = arrows
	bd1.DestRect.Initialize(vLeft, vTop, vLeft + vHeight, vTop + vHeight)
	bd2.Bitmap = arrows
	bd2.DestRect.Initialize(vLeft + vWidth - vHeight, vTop, vLeft + vWidth, vTop + vHeight)
	gv.BitmapsData.Add(bd1)
	gv.BitmapsData.Add(bd2)
	radius = height / 8
	jleft.bd.Bitmap = CreateBitmap(jleft.color)
	jleft.bd.DestRect.Initialize(0, 0, 0,0)
	gv.BitmapsData.Add(jleft.bd)	
	
	jright.bd.Bitmap = CreateBitmap(jright.color)
	jright.bd.DestRect.Initialize(0, 0, 0,0)
	gv.BitmapsData.Add(jright.bd)
	
	jleft.zeroX = height / 2
	jleft.zeroY = height / 2
	jright.zeroX = width - height / 2
	jright.zeroY = height / 2
	MoveJoystick(jleft.zeroX, jleft.zeroY, jleft)
	MoveJoystick(jright.zeroX, jright.zeroY, jright)
End Sub

Private Sub CreateBitmap(color As Int) As Bitmap
	Dim b As Bitmap
	b.InitializeMutable(radius * 2, radius * 2)
	Dim cvs As Canvas
	cvs.Initialize2(b)
	cvs.DrawCircle(radius, radius, radius, color, True, 0)
	Return b
End Sub

Private Sub pnl_multitouch(View As Object, pointerID As Int, action As Int, x As Float, y As Float) As Boolean
	Select action
        Case ges.ACTION_DOWN, ges.ACTION_POINTER_DOWN
            TouchMap.Put(pointerID, Null)
        Case ges.ACTION_POINTER_UP
            TouchMap.Remove(pointerID)
        Case ges.ACTION_UP
            TouchMap.Clear
    End Select
	Dim foundLeft, foundRight As Boolean
	For i = 0 To TouchMap.Size - 1
		Dim rawX, rawY As Float
		rawX = ges.GetX(TouchMap.GetKeyAt(i)) - pnlRect.LEFT
		rawY = ges.GetY(TouchMap.GetKeyAt(i)) - pnlRect.Top
		Dim gx, gy As Float
		gx = Max(0, Min(rawX, width))
		gy = Max(0, Min(rawY, height))
		If gx < width / 2 Then
			gx = Min(gx, height)
			MoveJoystick(gx, gy, jleft)
			foundLeft = True
		Else
			gx = Max(gx, width - height)
			MoveJoystick(gx, gy, jright)
			foundRight = True
		End If
	Next
	If Not(foundLeft) Then MoveJoystick(jleft.zeroX, jleft.zeroY, jleft)
	If Not(foundRight) Then MoveJoystick(jright.zeroX, jright.zeroY, jright)
	Return True
End Sub

Private Sub MoveJoystick(x As Float, y As Float, j As joystick)
	Dim valuex, valuey As Float
	valuex = x - j.zeroX
	valuey = y - j.zeroY
	If Abs(valuex) > Abs(valuey) Then y = j.zeroY Else x = j.zeroX
	j.x = x
	j.y = y
	j.bd.DestRect.LEFT = j.x - radius + pnlRect.LEFT
	j.bd.DestRect.Top = j.y - radius + pnlRect.Top
	j.bd.DestRect.RIGHT = j.bd.DestRect.LEFT + 2 * radius
	j.bd.DestRect.Bottom = j.bd.DestRect.Top + 2 * radius
End Sub

Public Sub GetLeftValue As Int
	Return GetValue(jleft)
End Sub

Public Sub GetRightValue As Int
	Return GetValue(jright)
End Sub

Private Sub GetValue(j As joystick) As Int
	If Power(j.x - j.zeroX, 2) + Power(j.y - j.zeroY, 2) < Power(height / 6, 2) Then
		Return NONE
	Else If j.x < j.zeroX Then 
		Return LEFT
	Else If j.x > j.zeroX Then
		Return RIGHT
	Else If j.y > j.zeroY Then
		Return DOWN
	Else If j.y < j.zeroY Then
		Return UP
	End If
End Sub