﻿Type=Class
Version=2.02
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private animator As SpriteAnimator
	Private bd As BitmapData
	Private game As GameManager
	Private ticksLeft As Int
	Public delete As Boolean
	Private collision As CollisionDetector
End Sub

Public Sub Initialize (vBD As BitmapData, vAnimator As SpriteAnimator, vGame As GameManager)
	animator = vAnimator
	bd = vBD
	game = vGame
	ticksLeft = 250
	animator.AnimationInterval = 10
	animator.width = 4 * GameUtils.scale
	animator.height = 8 * GameUtils.scale
	'create a collision detector that will detect collisions between this missile and the asteroids.
	collision.Initialize(bd.DestRect, game.Asteroids, 10, 0)
End Sub

Public Sub Tick
	animator.Tick(bd)
	Dim ast As Asteroid
	'check whether the missile has hit any asteroid
	ast = collision.Tick
	If ast <> Null Then
		game.PlaySound(game.breakSoundId, 1)
		ast.Explode
		ticksLeft = 0 'this will cause this missile to be removed.
	End If
	ticksLeft = ticksLeft - 1
	If ticksLeft <= 0 Then
		bd.delete = True
		delete = True
	End If
End Sub